#! /bin/ksh
#**********************************************************************#
#       Name:      start.sh                                            #
#       Funktion:  Updateroutine                                       #
#                  (Sichern, Aktualisieren und Konvertieren)           #
#----------------------------------------------------------------------#
#Parameter $1 bis $4 werden aus dem Script instxoil uebergeben         #
#$1 = Laufzeitumgebung      (z.B. /u/xpoint/?cu)                       #
#$2 = Protokolldatei        (z.B. /u/xpoint/?cu/LISTE/UPDPRT.DRU)      #
#$3 = ran-Befehl            (z.B. /etc/ran oder /etc/ranbcu)           #
#$4 = Sicherungsverzeichnis (z.B. /u/xpoint/xpva_?cu)                  #
#**********************************************************************#
#PROTO=/u/xpoint/acu/LISTE/UPDPRT.DRU
#ACUVR=/u/xpoint/acu
OSVAR=`uname`
ACUVR=$1
export ACUVR
PROTO=$2
export PROTO
RUNCBL=$3
ACUSVR=$4
###
###--------------- Loeschen + Neuanlage xpva_[Instanz]
###
clear
echo "                                                         "
echo " * Xpoint Software GmbH, Buchenstr.6, 95339 Neuenmarkt * "
echo " ------------------------------------------------------- "
echo "    X-oil Update $updversion                             "
echo " ------------------------------------------------------- "
echo "                                                         "
echo "                                                         "
echo "    Installationsschritte:                               "
echo "                                                         "
#/bin/rm -rf $ACUSVR 2>> $PROTO
#hw 13.02.2014
cd $ACUSVR
for i in *.acu
do
   rm -f $i
done
#hw
XX=`head -1 $ACUVR/DATEN/LSSTEUER`
KUNDE=`echo $XX`
if [ -s $ACUVR/acufirma ]
then
   XX=`head -1 $ACUVR/acufirma`
   FIRMA=`echo $XX`
else
   FIRMA=
fi
echo " -- Beginn start.sh: `date '+%d.%m.%Y/%H:%M:%S'` "          > $PROTO
echo "                                                         " >> $PROTO
echo " ------------------------------------------------------- " >> $PROTO
echo "    X-oil Update $updversion                             " >> $PROTO
echo " ------------------------------------------------------- " >> $PROTO
echo "                                                         " >> $PROTO
echo "    Kundenkennung: $FIRMA   $KUNDE                       " >> $PROTO
echo "    Instanz:       $ACUVR                                " >> $PROTO
echo "                                                         " >> $PROTO
echo "    Installationsschritte:                               " >> $PROTO
echo "                                                         " >> $PROTO
#hw 14.02.2014
mkdir -p $ACUSVR/$updversion/acu 2>> $PROTO
###
###--------------- sekundaere cblconfig abstellen, damit die
###--------------- alle die aufgerufenen Programme in der richtigen
###--------------- Instanz laufen!!
###
#hw#???#cp -p xpv/cblconfig $ACUVR
###
###--------------- Aufraeumarbeiten VOR dem Update
###
echo "    - bernahme Archivdaten            "
echo "    - bernahme ARCHIV in ZWSORT, SP098" >> $PROTO
cd $ACUVR
$RUNCBL SP098
###
###--------------- ALLE Programme nach ../xpva_[Instanz]/[Update_Version] sichern
###
echo "    - Programmstand (alt) sichern"
echo "    - Programmstand (alt) sichern" >> $PROTO
#hw 14.02.2014
cd $ACUVR
for i in *.acu
do
   cp -p $i $ACUSVR/$updversion/acu/ 2>> $PROTO
done
###--------------- ../xpva_[Instanz]/[Update_Version] --> tar + gzip
cd $ACUSVR/$updversion
tar cf tarfile ./acu
gzip tarfile
#--- nur, wenn tar/gzip erfolgreich, knnen die .acu gelscht werden
if [ -s tarfile.gz ]
then
   echo "    - Programmstand (alt) tar+gzip OK" >> $PROTO
   rm -rf $ACUSVR/$updversion/acu
fi
#hw-----
###--------------- xo037D2 loeschen
cd $ACUVR
/bin/rm -f xo037D2.acu 2>> $PROTO
###
###--------------- Kopieren der Programme nach /u/xpoint/[Instanz]
###
echo "    - Programmstand (neu) installieren"
echo "    - Programmstand (neu) installieren" >> $PROTO
cd /u/xpoint/xpv
#hw---- Update 05.2014:
#hw---- FF040 nicht zu Kunden, die das FNOPEXPORT noch nicht einsetzen,
#hw---- zu allen anderen MUSS das FF040!
case $KUNDE in
rapp)
    rm FF040.acu
    echo "    - FF040 ignorieren"
    echo "    - FF040 ignorieren" >> $PROTO
    ;;
esac
for i in *.acu
 do
 cp -p $i $ACUVR 2>> $PROTO
done
#hw---- 
###
###--------------- Hilfetexte aktualisieren
###
echo "    - Hilfetexte aktualisieren"
echo "    - Hilfetexte aktualisieren" >> $PROTO
cd /u/xpoint/xpv
cp -p -r X/HLP/* $ACUVR/X/HLP/ 2>> $PROTO
###
###--------------- weitere Systemdateien aktualisieren
###                (Scripte, Bitmaps, etc.)
###
echo "    - Systemdateien von X-oil aktualisieren"
echo "    - Systemdateien von X-oil aktualisieren" >> $PROTO
cd /u/xpoint/xpv
cp -p work/XP/progfil $ACUVR/work/XP/ 2>> $PROTO
###---------------  nur Update 06/2015:
#cp -p work/XP/xo404.xlsx $ACUVR/work/XP/ 2>> $PROTO
###
###
#echo "    - Kurzbefehle aktualisieren"
echo "    - Kurzbefehle aktualisieren"
echo "    - Kurzbefehle aktualisieren" >> $PROTO
cp -p ucb/XP/* $ACUVR/ucb/XP/ 2>> $PROTO
chmod -R 777 $ACUVR/ucb/XP/*
###
###--------------- Scripts sichern
###
cp -p  $ACUVR/SCRIPTS/xpnachtlauf $ACUVR/SCRIPTS/xpnachtlauf.$updversion 2>> $PROTO
cp -p  $ACUVR/SCRIPTS/xplizenz    $ACUVR/SCRIPTS/xplizenz.$updversion 2>> $PROTO
#cp -p  $ACUVR/SCRIPTS/xpcheck     $ACUVR/SCRIPTS/xpcheck.$updversion     2>> $PROTO
#cp -p  $ACUVR/SCRIPTS/acukill     $ACUVR/SCRIPTS/acukill.$updversion     2>> $PROTO
#cp -p  $ACUVR/SCRIPTS/archivxo    $ACUVR/SCRIPTS/archivxo.$updversion    2>> $PROTO
###
#hw###- nur Update 05/2014
#hw###-
#hw###- FIBU-Sicherungen in Faktura-Scripts anpassen
#hw###  (ACHTUNG: geht nicht mit EINER Schleife !!!!)
#tmp1=/tmp/start.sh1$$
#echo "$ACUVR/SCRIPTS/xoilfakt.acu"   > $tmp1
#echo "$ACUVR/SCRIPTS/moilfakt.acu"  >> $tmp1
#echo "$ACUVR/SCRIPTS/m5fakt.acu"    >> $tmp1
#- Schleife-1: sichern
#cat ${tmp1} |
#while read fdat
#do 
#   FAKT=$fdat
#   echo "    - $FAKT sichern ..."   >> $PROTO
#   cp -p $FAKT $FAKT.$updversion      2>> $PROTO
#done
#- Schleife-2: ndern
#cat ${tmp1} |
#while read fdat
#do 
#   FAKT=$fdat
#   echo "    - $FAKT aktualisieren ..." >> $PROTO
#   cat $FAKT.$updversion | sed 's/"+%m.%d_%H:%M"/"+%Y%m%d_%H%M%S"/g' | sed 's/"+%m.%d_%H%M%S"/"+%Y%m%d_%H%M%S"/g' > $FAKT 2>> $PROTO
#done
#- Schleife-3: prfen
#cat ${tmp1} |
#while read fdat
#do 
#   FAKT=$fdat
#   if [ -s  $FAKT ]
#   then
#      echo "    - $FAKT aktualisieren - OK"       >> $PROTO
#   else
#      echo "    - $FAKT aktualisieren - ERROR!!!" >> $PROTO
#   fi
#done
#rm $tmp1
#hw###- nur Update 05/2014 - ENDE
###
###
###--------------- neue Scripte bereit stellen
###--------------- neue Bilder fuer Buttons (z.B. Tool-Bar)
###
cd /u/xpoint/xpv
cp -p  -r SCRIPTS/* $ACUVR/SCRIPTS/ 2>> $PROTO
#hw###########################################################
###
###--------------- Bei Weissert muss das xpnachtlauf um einen Zusatz
###--------------- ergnzt werden!
#hw file1=$ACUVR/SCRIPTS/xpnachtlauf
#hw case $KUNDE in
#hw weissert_old) case $(head -1 ${file1} | grep "#!/bin/bash") in
#hw           "") echo "#!/bin/bash"  > /tmp/xp1_$$
#hw               cat ${file1}       >> /tmp/xp1_$$
#hw               cp -p /tmp/xp1_$$ ${file1}
#hw               rm /tmp/xp1_$$
#hw               ;;
#hw           esac
#hw           ;;
#hw esac
#hw###########################################################
###--------------- Administration Listenverwaltung (../X/SYS/LISTVW)
###--------------- aus csv-Datei (../word/texte/allelist.csv)
###--------------- aufbauen
#echo "    - Aktualisierung Listenbezeichnungen, FF512 "
#echo "    - Aktualisierung Listenbezeichnungen, FF512 " >> $PROTO
#cp -p /u/xpoint/xpv/word/texte/allelist.csv $ACUVR/word/texte/ 2>> $PROTO
#cd $ACUVR
#$RUNCBL FF512
###-------------------------------------------------------------------
###---------------  nur Update 02/2015:
###--------------- 
###--------------- Datei TDLSYS nach X/XO1 kopieren
###--------------- 
#echo "    - TDLSYS-Datei nach X/XO1 kopieren " >> $PROTO
#cp -p $ACUVR/X/XO1/TDLSYS $ACUVR/X/XO1/TDLSYS.$updversion 2>> $PROTO
#cp -p /u/xpoint/xpv/X/XO1/TDLSYS $ACUVR/X/XO1/ 2>> $PROTO
###-------------------------------------------------------------------
###--------------- 
###--------------- Datei TARGET nach DATEN kopieren
###--------------- 
#hw echo "    - TARGET-Datei kopieren " >> $PROTO
#hw cp -p /u/xpoint/xpv/DATEN/TARGET* $ACUVR/DATEN/ 2>> $PROTO
###
###--------------- Aufruf der Konvertierungsprogramme
###
echo "    - Konvertierungsprogramme starten"
echo "    - Konvertierungsprogramme" >> $PROTO
#hw# -------------------------------------------------------------
#hw# --- nur fr Update 05.2014 !!!
#hw# -------------------------------------------------------------
###--------------- Konvertierung BESUCH von 800 --> 1000
#echo "      Konvertierung: BESUCH" >> $PROTO
#cd $ACUVR
#mkdir -p DATEN/save >/dev/null 2>&1
#cp -p DATEN/BESUCH* DATEN/save/
#$RUNCBL FF595
###--------------- Konvertierung Fremdsprachendatei wegen Anpassungen
###--------------- vom Druckbild der Rechnungen
#hw#echo "      Konvertierung: Fremdsprachendatei" >> $PROTO
#hw#cd $ACUVR
#hw#$RUNCBL FF5081
###--------------- Konvertierung Bankenstamm
#hw#echo "      Konvertierung: Bankenstamm" >> $PROTO
#hw#cd $ACUVR
#hw#$RUNCBL FF563
#hw# -------------------------------------------------------------
#hw# --- nur fr Update 07.2015 !!!
#hw# -------------------------------------------------------------
###--------------- Konvertierungen/Initialisierungen
#cd $ACUVR
#mkdir -p DATEN/save >/dev/null 2>&1
###--------------- Initialisierung KUNDT2
#echo "      Initialisierung KUNDT2" >> $PROTO
#cp -p DATEN/KUNDT2* DATEN/save/ 2>> $PROTO
#$RUNCBL FF616 2>> $PROTO
###--------------- Initialisierung SYSTAB
#echo "      Initialisierung SYSTAB" >> $PROTO
#cp -p DATEN/SYSTAB* DATEN/save/ 2>> $PROTO
#$RUNCBL FF618 2>> $PROTO
#hw# -------------------------------------------------------------
#hw# --- nur fr Update 09.2015 !!!
#hw# -------------------------------------------------------------
###--------------- Konvertierungen/Initialisierungen
cd $ACUVR
mkdir -p DATEN/save >/dev/null 2>&1
###--------------- Konvertierung Email-Signatur
echo "      Konvertierung Email-Signatur" >> $PROTO
cp -p DATEN/KUNDT2* DATEN/save/ 2>> $PROTO
cp -p DATEN/EMAIL* DATEN/save/ 2>> $PROTO
$RUNCBL FF622 2>> $PROTO
###--------------- Konvertierung TELEFN
echo "      Konvertierung TELEFN" >> $PROTO
cp -p DATEN/TELEFN* DATEN/save/ 2>> $PROTO
$RUNCBL FF623 2>> $PROTO
###--------------- Initialisierung SYSTAB
echo "      Initialisierung SYSTAB" >> $PROTO
cp -p DATEN/SYSTAB* DATEN/save/ 2>> $PROTO
$RUNCBL FF626 2>> $PROTO
###--------------- Lschen Log-Datei
echo "      Protokolldatei sp0412.log lschen" >> $PROTO
rm X/log/xo/sp0412.log  2>> $PROTO
###
###--------------- Matchcodedatei neuaufbauen
###
#hw#echo "    - Neuaufbau Matchcodedatei... bitte warten!"
#hw#echo "      (Dieser Vorgang kann einige Minuten in Anspruch nehmen!)"
#hw#echo "    - Neuaufbau Matchcodedatei, SP021                       " >> $PROTO
#hw#cd $ACUVR
#hw#$RUNCBL SP021
###--------------- Sepa-Vorlage
#hw#cd /u/xpoint/xpv/
#hw#cp -p word/texte/sepa $ACUVR/word/texte/sepa 2>> $PROTO
#hw#echo "    - SEPA-Vorlage eintragen"
#hw#cd $ACUVR
#hw#$RUNCBL FF570
#hw#rm -f $ACUVR/word/texte/sepa
###--------------- Menuedatei, Eintraege ergaenzen
#hw
cd /u/xpoint/xpv/
cp -p word/texte/meninput.csv $ACUVR/meninput.csv 2>> $PROTO
echo "    - Mendatei aktualisieren"
echo "    - Mendatei aktualisieren" >> $PROTO
cd $ACUVR
$RUNCBL xomened 2>> $PROTO
rm -f $ACUVR/meninput.csv
#hw# -------------------------------------------------------------
#hw# --- nur fr Update 12.2013 !!!
#hw# -------------------------------------------------------------
###
###--------------- Rechnungsarchive bereinigen
###
#hw#echo "    - Rechnungsarchive bereinigen"
#hw#echo "    - Rechnungsarchive bereinigen" >> $PROTO
#hw#rm -f $ACUVR/gzip
#hw#rm -f $ACUVR/gunzip
#hw, 31.01.2014: 21-X021B (SPPDS) wird durch 22-X022B (SPPDS1) ersetzt!
#hw, 17.02.2014 - wieder raus genommen :-(
######rm -f $ACUVR/SPPDS.acu
#hw#cd $ACUVR
#hw#./SCRIPTS/archivkorr $ACUVR >> $PROTO 2>&1
#hw# -------------------------------------------------------------
#hw# --- nur fr Update 05.2014 !!!
#hw# -------------------------------------------------------------
#echo "    - Mendatei TK aktualisieren"
#echo "    - Mendatei TK aktualisieren" >> $PROTO
#cd $ACUVR
#$RUNCBL TKFF329 2>> $PROTO
#hw# -------------------------------------------------------------
###
###--------------- eventuell vorhandenen Bugfix-Ordner einspielen
###
#cd /u/xpoint
#[ -d $bugfix ] && echo "    - Bugfixes einspielen"
#[ -d $bugfix ] && echo "    - Bugfixes einspielen" >> $PROTO
#[ -d $bugfix ] && cp -p -R $bugfix/* $ACUVR 2>> $PROTO
###
###--------------- Rechte auf die wichtigsten Verzeichnisse setzen
###
echo "    - Rechte setzen... bitte warten!"
echo "      (Dieser Vorgang kann einige Minuten in Anspruch nehmen!)"
echo "    - Rechte setzen"   >> $PROTO
chmod -R 777 $ACUVR/DATEN   2>> $PROTO
chmod -R 777 $ACUVR/work/xo 2>> $PROTO
chmod -R 777 $ACUVR/LISTE   2>> $PROTO
chmod -R 777 $ACUVR/X/SYS   2>> $PROTO
chmod -R 777 $ACUVR/X/XO1   2>> $PROTO
chmod -R 777 $ACUVR/X/XO2   2>> $PROTO
chmod -R 777 $ACUVR/DATXP   2>> $PROTO
chmod -R 777 $ACUVR/SCRIPTS 2>> $PROTO
$ACUVR/SCRIPTS/modus 2> /dev/null >> /dev/null
###
###--------------- Version fixieren
###
cd $ACUVR
echo "    - Version $updversion fixieren"
echo "    - Version $updversion fixieren" >> $PROTO
cat $ACUVR/acuversion >> acuversion.alt 2>> $PROTO
echo "Xenergy $FIRMA - Version $updversion " > $ACUVR/acuversion 2>> $PROTO
#case $KUNDE in
#     wahr)     echo "Fa. Wahr - Version $updversion " > $ACUVR/acuversion 2>> $PROTO
#     ;;
#     bww)      echo "Fa. BWW Version $updversion " > $ACUVR/acuversion 2>> $PROTO
#     ;;
#     luehmann) echo "Xenergy CLASSIC Version $updversion " > $ACUVR/acuversion 2>> $PROTO
#     ;;
#     sln2)     echo "Xenergy SLN2 Version $updversion " > $ACUVR/acuversion 2>> $PROTO
#     ;;
#esac
#hw
cat $ACUVR/xoilversion >> xoilversion.alt 2>> $PROTO
echo $updversion > $ACUVR/xoilversion 2>> $PROTO
###
#hw---- Update 08.2014:
###
###--------------- Verzeichnisse fuer XDIAL anlegen und fllen
#mkdir -p $ACUVR/xdial 2>> $PROTO
#cp -p -r /u/xpoint/xpv/xdial/* $ACUVR/xdial/ 2>> $PROTO
###--------------- Verzeichnisse fuer WINTOOL anlegen und fllen
#mkdir -p /u/xpoint/prog/wintool 2>> $PROTO
#cp -p -r /u/xpoint/xpv/prog/wintool/* /u/xpoint/prog/wintool 2>> $PROTO
#hw---- Update 08.2014 - ENDE
###
###
###--------------- Verzeichnisse fuer Remoteuntersttzung anlegen
###
###
#hw#cd /u/xpoint
#hw#echo "    - neue Verzeichnisse anlegen"
#hw#echo "    - neue Verzeichnisse anlegen" >> $PROTO
#hw#mkdir -p /u/xpoint/prog/teamviewer 2>> $PROTO
#hw#mkdir -p $ACUVR/upd/Xoil-FTP 2>> $PROTO
#hw#mkdir -p $ACUVR/upd/config 2>> $PROTO
#hw#echo "    - Rechte in neuen Verzeichnissen setzen"
#hw#echo "    - Rechte in neuen Verzeichnisse setzen    " >> $PROTO
#hw#chmod -R 777 /u/xpoint/prog
#hw#chmod -R 777 $ACUVR/upd
#
#hw---- Verzeichnis ../sparchiv anlegen
#hw#mkdir -p $ACUVR/sparchiv
#hw#chmod 777 $ACUVR/sparchiv
###
###--------------- Sambafreigabe, Prog-Verzeichnis anlegen
###
#echo "    - Freigabe prog einrichten"
#echo "    - Freigabe 'prog' einrichten" >> $PROTO
#$ACUVR/SCRIPTS/freigabe.sh
#/bin/rm -f $ACUVR/SCRIPTS/freigabe.sh
###
###--------------- aktuelle Teamviewer_QS.exe verteilen
###
echo "    - Teamviewer_QS / Updateschreiben aktualisieren"
echo "    - Teamviewer_QS / Updateschreiben aktualisieren" >> $PROTO
cd /u/xpoint
cp -p -r xpv/prog /u/xpoint/ 2>> $PROTO
chmod -R 777 /u/xpoint/prog
###--------------- Aufraeumarbeiten NACH dem Update
###
echo "    - Aufrumen"
echo "    - Aufrumen" >> $PROTO
#hw# -------------------------------------------------------------
#hw# --- nur fr Update 06.2015 !!!
#hw# -------------------------------------------------------------
###erst mal noch drauf lassen# /bin/rm -f $ACUVR/localpri*.acu 2>> $PROTO
###erst mal noch drauf lassen# /bin/rm -f $ACUVR/XPERRW.acu    2>> $PROTO
###erst mal noch drauf lassen# /bin/rm -f $ACUVR/XPERR.acu     2>> $PROTO
###erst mal noch drauf lassen# /bin/rm -f $ACUVR/xperrw.acu    2>> $PROTO
###erst mal noch drauf lassen# /bin/rm -f $ACUVR/xperr.acu     2>> $PROTO
#/bin/rm -f $ACUVR/spdats.acu 2>> $PROTO
#/bin/rm -f $ACUVR/XODOKU.acu 2>> $PROTO
#/bin/rm -f $ACUVR/TELEXPORT.acu 2>> $PROTO
#/bin/rm -f $ACUVR/TELEX.acu 2>> $PROTO
#/bin/rm -f $ACUVR/xovwdw.acu 2>> $PROTO
#/bin/rm -f $ACUVR/xovwdw2.acu 2>> $PROTO
#/bin/rm -f $ACUVR/xovwdw3.acu 2>> $PROTO
#/bin/rm -f $ACUVR/xovwdb3.acu 2>> $PROTO
#/bin/rm -f $ACUVR/xovmdw2.acu 2>> $PROTO
###
###--------------- Kopie des Updateprotokoll erstellen, falls das
###                Orginal (.DRU) vom Benutzer zuvor geloescht wird!
###
echo "                                                         " >> $PROTO
echo " ------------------------------------------------------- " >> $PROTO
echo " -- Ende start.sh: `date '+%d.%m.%Y/%H:%M:%S'` "           >> $PROTO
cp -p -f $PROTO $ACUVR/LISTE/UPDPRT_$updversion.log
#hw, 20.02.2014: Update-Protokoll im Protokoll-Ordner archivieren
mkdir -p $ACUVR/protokoll/updates
cp -p -f $PROTO $ACUVR/protokoll/updates/UPDPRT_$updversion.log
###
###--------------- Endemeldung, Abschluss
###
echo "                                                         "
echo " ------------------------------------------------------- "
echo "                                                         "
echo "    Ende der Updateroutine                               "
echo "                                                         "
echo "    WEITER mit Enter \c"
read eingabe
#***********************************************************************
#*END*OF*start.sh*******************************************************
